//=============================================================================
// CheckCredits
//
// Code is unusually long because it can also wait for player's confirmation of
// spending the credits
// 
// I messed up slightly though
//=============================================================================
Class CheckCredits extends MPConvo_Trigger;

enum convType
{
	Personal,
	Cooperative
};

var(MPC_CheckCredits) int checkCreditsAmount;
var(MPC_CheckCredits) string productDescription;
var(MPC_CheckCredits) bool bTakeCredits;
var DeusExPlayer spender;
var float spendTimer;

function Trigger(Actor Other, Pawn EventInstigator) //Does Trigger() trigger Event? Just tested it, and nope. It doesn't seem to
{
	if((coolDown <= Level.TimeSeconds) || (EventInstigator != lastPawn))
	{	
		coolDown = Level.TimeSeconds + 0.5; //don't let spammy players cause lag
		lastPawn = EventInstigator;

		DoBoringStuff(DeusExPlayer(EventInstigator));
		DoCoolStuff(DeusExPlayer(EventInstigator));
	}
}

function DoBoringStuff(DeusExPlayer Instigator)
{
	local MissionProgress A;
	local actor A2;
	local bool bs; //let's be lazy

	//removed an "if mission != 0" here

	foreach AllActors(class 'MissionProgress', A)
	{
		if(A.Owner == Instigator)
		{
			switch (checkRange)
			{
				case Exactly:

				if(checkMissionState == A.GetMissionState(missionNumber, bCoop))
				{
					bs=true;

					if(Instigator.Credits >= checkCreditsAmount)
					{
						if(bTakeCredits == true)
						{
							if(spendTimer <= Level.TimeSeconds) //first, remove old spender if they took too long
							{
								spender = none;
							}

							if(spender == none)
							{
								spender = Instigator;
								spendTimer = Level.TimeSeconds + 4.0; //is 4 seconds enough to decide? might adjust
									
								Instigator.ClientMessage("|p7Click again to confirm spending "$checkCreditsAmount$" credits on "$productDescription);
								return;
							}
							else
							{
								if(spender == Instigator)
								{
									Instigator.Credits -= checkCreditsAmount;
									Instigator.ClientMessage("|p1"$checkCreditsAmount$" credits spent");
									A.SetMissionState(missionNumber,setMissionState, bCoop);
								}
								else
								{
									Instigator.ClientMessage("|p1Please wait");
									return;
								}
							}
						}
						else
						{
							A.SetMissionState(missionNumber,setMissionState, bCoop);
						}
					}
					else
					{
						Instigator.ClientMessage("|p2You don't have "$checkCreditsAmount$" credits!");
						return;
					}
				}
				else
				{
					return;
				}

				break;

				case To_value2:

				if((checkMissionState <= A.GetMissionState(missionNumber, bCoop)) && (checkMissionState >= A.GetMissionState(missionNumber, bCoop)))
				{
					bs=true;

					if(Instigator.Credits >= checkCreditsAmount)
					{
						if(bTakeCredits == true)
						{
							if(spendTimer <= Level.TimeSeconds) //first, remove old spender if we're too late
							{
								spender = none;
							}

							if(spender == none)
							{
								spender = Instigator;
								spendTimer = Level.TimeSeconds + 4.0; //is 4 seconds enough to decide? might adjust
									
								Instigator.ClientMessage("|p7Click again to confirm spending "$checkCreditsAmount$" credits on "$productDescription);
								return;
							}
							else
							{
								if(spender == Instigator)
								{
									Instigator.Credits -= checkCreditsAmount;
									Instigator.ClientMessage("|p1"$checkCreditsAmount$" credits spent");
									A.SetMissionState(missionNumber,setMissionState, bCoop);
								}
								else
								{
									Instigator.ClientMessage("|p1Please wait");
									return;
								}
							}
						}
						else
						{
							A.SetMissionState(missionNumber,setMissionState, bCoop);
						}
					}
					else
					{
						Instigator.ClientMessage("|p2You don't have "$checkCreditsAmount$" credits!");
						return;
					}
				}
				else
				{
					return;
				}

				break;
			}
		}
	}

	if(bs)
	{
		//broadcastmessage("|p2DEBUG: Event triggered");
		if(Event != '')
		{
			foreach AllActors(class 'Actor', A2, Event)
			{
				A2.Trigger(Self,Instigator);
				spender = none;
			}
		}
	}
}

function BeginPlay()
{
	if(missionType == Cooperative)
	{
		bCoop = true;
	}

	Super.BeginPlay();
}

defaultproperties
{
     bTakeCredits=true
     productDescription="|p2default item message"
}